---
type: api
title: Create a saved query
description: **Spaces method and path for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana-serverless/operation/operation-osquerycreatesavedquery
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana-serverless/operation/operation-osquerycreatesavedquery
products:
  - Kibana
---

# Create a saved query

- Server: `https://{kibana_url}`

## Paths

- `POST` `/api/osquery/saved_queries`
- `POST` `/s/{space_id}/api/osquery/saved_queries`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/kibana-serverless/authentication#apikeyauth)

## Description

Refer to [Spaces](https://www.elastic.co/docs/deploy-manage/manage-spaces) for more information.

Create and save a query for later use.

## Request Body

`application/json`

- `description` (string) — optional
  The saved query description.
- `ecs_mapping` (object) — optional
  Map osquery results columns or static values to Elastic Common Schema (ECS) fields
- `id` (string) — optional
  The ID of a saved query.
- `interval` (string) — optional
  An interval, in seconds, on which to run the query.
- `platform` (string) — optional
  Restricts the query to a specified platform. The default is all platforms. To specify multiple platforms, use commas. For example, `linux,darwin`.
- `query` (string) — optional
  The SQL query you want to run.
- `removed` (boolean) — optional
  Indicates whether the query is removed.
- `snapshot` (boolean) — optional
  Indicates whether the query is a snapshot.
- `version` (string) — optional
  Uses the Osquery versions greater than or equal to the specified version string.

## Response

Indicates a successful call.

`application/json`

- `data` (object)
  - `created_at` (string)
  - `created_by` (string) — nullable
  - `created_by_profile_uid` (string)
  - `description` (string)
    The saved query description.
  - `ecs_mapping` (object)
    Map osquery results columns or static values to Elastic Common Schema (ECS) fields
  - `id` (string)
    The ID of a saved query.
  - `interval` (integer | string)
    An interval, in seconds, on which to run the query. May be returned as number or string.
  - `platform` (string)
    Restricts the query to a specified platform. The default is all platforms. To specify multiple platforms, use commas. For example, `linux,darwin`.
  - `prebuilt` (boolean)
    Whether the saved query is prebuilt.
  - `query` (string)
    The SQL query you want to run.
  - `removed` (boolean)
    Indicates whether the query is removed.
  - `saved_object_id` (string)
    The saved object ID of the saved query.
  - `snapshot` (boolean)
    Indicates whether the query is a snapshot.
  - `timeout` (integer)
    The query timeout in seconds.
  - `updated_at` (string)
  - `updated_by` (string) — nullable
  - `updated_by_profile_uid` (string)
  - `version` (integer | string)
    The saved query version.
## Code Examples

#### Console

```console
POST /api/osquery/saved_queries
{
  "description": "Saved query description",
  "ecs_mapping": {
    "host.uptime": {
      "field": "total_seconds"
    }
  },
  "id": "my_saved_query",
  "interval": "60",
  "platform": "linux,darwin",
  "query": "select * from uptime;",
  "timeout": 120
}
```

#### curl

```curl
curl -X POST "https://{kibana_url}/api/osquery/saved_queries" \
  -H "Content-Type: application/json" \
  -d '{
  "description": "Saved query description",
  "ecs_mapping": {
    "host.uptime": {
      "field": "total_seconds"
    }
  },
  "id": "my_saved_query",
  "interval": "60",
  "platform": "linux,darwin",
  "query": "select * from uptime;",
  "timeout": 120
}'
```

## Response Examples

#### Saved query created

```json
{
  "data": {
    "created_at": "2025-02-26T13:37:30.452Z",
    "created_by": "elastic",
    "description": "Saved query description",
    "ecs_mapping": {
      "host.uptime": {
        "field": "total_seconds"
      }
    },
    "id": "my_saved_query",
    "interval": "60",
    "platform": "linux,darwin",
    "query": "select * from uptime;",
    "saved_object_id": "42ba1280-2172-11ee-8523-5765fca79a3c",
    "timeout": 120,
    "updated_at": "2025-02-26T13:37:30.452Z",
    "updated_by": "elastic"
  }
}
```

